'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var BASE_CLASS = 'sui-AtomProgressBar';
var CLASS_INDICATOR = 'sui-AtomProgressBar-indicator';
var CLASS_CONTAINER_BAR = 'sui-AtomProgressBar-container';
var CLASS_BAR = 'sui-AtomProgressBar-bar';
var CLASS_BAR_ANIMATED = 'sui-AtomProgressBar-bar--animated';

var Indicator = function Indicator(props) {
  var indicatorBottom = props.indicatorBottom,
      percentage = props.percentage,
      indicatorTotal = props.indicatorTotal; // eslint-disable-line react/prop-types

  return _react2.default.createElement(
    'span',
    {
      className: (0, _classnames2.default)(CLASS_INDICATOR, CLASS_INDICATOR + '--' + (indicatorBottom ? 'bottom' : 'top'))
    },
    _react2.default.createElement(
      'strong',
      null,
      percentage
    ),
    indicatorTotal ? '/100' : '%'
  );
};

var AtomProgressBar = function (_PureComponent) {
  (0, _inherits3.default)(AtomProgressBar, _PureComponent);

  function AtomProgressBar() {
    (0, _classCallCheck3.default)(this, AtomProgressBar);
    return (0, _possibleConstructorReturn3.default)(this, (AtomProgressBar.__proto__ || (0, _getPrototypeOf2.default)(AtomProgressBar)).apply(this, arguments));
  }

  (0, _createClass3.default)(AtomProgressBar, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          percentage = _props.percentage,
          indicatorBottom = _props.indicatorBottom,
          isAnimatedOnChange = _props.isAnimatedOnChange;

      var width = percentage + '%';
      var styleBar = { width: width };
      return _react2.default.createElement(
        'div',
        { className: BASE_CLASS },
        !indicatorBottom && _react2.default.createElement(Indicator, this.props),
        _react2.default.createElement(
          'div',
          { className: CLASS_CONTAINER_BAR },
          _react2.default.createElement('span', {
            className: (0, _classnames2.default)(CLASS_BAR, isAnimatedOnChange && CLASS_BAR_ANIMATED),
            style: styleBar
          })
        ),
        indicatorBottom && _react2.default.createElement(Indicator, this.props)
      );
    }
  }]);
  return AtomProgressBar;
}(_react.PureComponent);

AtomProgressBar.displayName = 'AtomProgressBar';

AtomProgressBar.propTypes = process.env.NODE_ENV !== "production" ? process.env.NODE_ENV !== "production" ? {
  /** Percentage value to be displayed as number and as bar width  */
  percentage: _propTypes2.default.number,

  /** If the indicator should be displayed with the pattern → {percentage}/100 ({percentage}% as default) */
  indicatorTotal: _propTypes2.default.bool,

  /** If the bar "value" (width) should be displayed wuth animation */
  isAnimatedOnChange: _propTypes2.default.bool,

  /** If the indicator should be placed below the bar */
  indicatorBottom: _propTypes2.default.bool
} : {} : {};

exports.default = AtomProgressBar;